Zero Sum Subarray

Question

  1. Given an integer array, find a subarray where the sum of numbers is zero.
  2. Your code should return the index of the first number and the index of the last number.
  3. Example
  4. Given [-3, 1, 2, -3, 4], return [0, 2] or [1, 3].
  5. Note
  6. There is at least one subarray that it's sum equals to zero.

题解1 - 两重 for 循环

题目中仅要求返回一个子串(连续)中和为0的索引,而不必返回所有可能满足题意的解。最简单的想法是遍历所有子串,判断其和是否为0,使用两重循环即可搞定,最坏情况下时间复杂度为 O(n^2), 这种方法显然是极其低效的,极有可能会出现 TLE. 下面就不浪费篇幅贴代码了。

题解2 - 比较子串和(TLE)

两重 for 循环显然是我们不希望看到的解法,那么我们再来分析下题意,题目中的对象是分析子串和,那么我们先从常见的对数组求和出发,f(i) = \sum _{0} ^{i} nums[i] 表示从数组下标 0 开始至下标 i 的和。子串和为0,也就意味着存在不同的 i_1i_2 使得 f(i_1) - f(i_2) = 0, 等价于 f(i_1) = f(i_2). 思路很快就明晰了,使用一 vector 保存数组中从 0 开始到索引i的和,在将值 push 进 vector 之前先检查 vector 中是否已经存在,若存在则将相应索引加入最终结果并返回。

C++

  1. class Solution {
  2. public:
  3. /**
  4. * @param nums: A list of integers
  5. * @return: A list of integers includes the index of the first number
  6. * and the index of the last number
  7. */
  8. vector<int> subarraySum(vector<int> nums){
  9. vector<int> result;
  10. int curr_sum = 0;
  11. vector<int> sum_i;
  12. for (int i = 0; i != nums.size(); ++i) {
  13. curr_sum += nums[i];
  14. if (0 == curr_sum) {
  15. result.push_back(0);
  16. result.push_back(i);
  17. return result;
  18. }
  19. vector<int>::iterator iter = find(sum_i.begin(), sum_i.end(), curr_sum);
  20. if (iter != sum_i.end()) {
  21. result.push_back(iter - sum_i.begin() + 1);
  22. result.push_back(i);
  23. return result;
  24. }
  25. sum_i.push_back(curr_sum);
  26. }
  27. return result;
  28. }
  29. };

源码分析

使用curr_sum保存到索引i处的累加和,sum_i保存不同索引处的和。执行sum_i.push_back之前先检查curr_sum是否为0,再检查curr_sum是否已经存在于sum_i中。是不是觉得这种方法会比题解1好?错!时间复杂度是一样一样的!根本原因在于find操作的时间复杂度为线性。与这种方法类似的有哈希表实现,哈希表的查找在理想情况下可认为是 O(1).

复杂度分析

最坏情况下 O(n^2), 实测和题解1中的方法运行时间几乎一致。

题解3 - 哈希表

终于到了祭出万能方法时候了,题解2可以认为是哈希表的雏形,而哈希表利用空间换时间的思路争取到了宝贵的时间资源 :)

C++

  1. class Solution {
  2. public:
  3. /**
  4. * @param nums: A list of integers
  5. * @return: A list of integers includes the index of the first number
  6. * and the index of the last number
  7. */
  8. vector<int> subarraySum(vector<int> nums){
  9. vector<int> result;
  10. // curr_sum for the first item, index for the second item
  11. map<int, int> hash;
  12. hash[0] = 0;
  13. int curr_sum = 0;
  14. for (int i = 0; i != nums.size(); ++i) {
  15. curr_sum += nums[i];
  16. if (hash.find(curr_sum) != hash.end()) {
  17. result.push_back(hash[curr_sum]);
  18. result.push_back(i);
  19. return result;
  20. } else {
  21. hash[curr_sum] = i + 1;
  22. }
  23. }
  24. return result;
  25. }
  26. };

源码分析

为了将curr_sum == 0的情况也考虑在内,初始化哈希表后即赋予 <0, 0>. 给 hash赋值时使用i + 1, push_back时则不必再加1.

由于 C++ 中的map采用红黑树实现,故其并非真正的「哈希表」,C++ 11中引入的unordered_map用作哈希表效率更高,实测可由1300ms 降至1000ms.

复杂度分析

遍历求和时间复杂度为 O(n), 哈希表检查键值时间复杂度为 O(\log L), 其中 L 为哈希表长度。如果采用unordered_map实现,最坏情况下查找的时间复杂度为线性,最好为常数级别。

题解4 - 排序

除了使用哈希表,我们还可使用排序的方法找到两个子串和相等的情况。这种方法的时间复杂度主要集中在排序方法的实现。由于除了记录子串和之外还需记录索引,故引入pair记录索引,最后排序时先按照sum值来排序,然后再按照索引值排序。如果需要自定义排序规则可参考[^sort_pair_second].

C++

  1. class Solution {
  2. public:
  3. /**
  4. * @param nums: A list of integers
  5. * @return: A list of integers includes the index of the first number
  6. * and the index of the last number
  7. */
  8. vector<int> subarraySum(vector<int> nums){
  9. vector<int> result;
  10. if (nums.empty()) {
  11. return result;
  12. }
  13. const int num_size = nums.size();
  14. vector<pair<int, int> > sum_index(num_size + 1);
  15. for (int i = 0; i != num_size; ++i) {
  16. sum_index[i + 1].first = sum_index[i].first + nums[i];
  17. sum_index[i + 1].second = i + 1;
  18. }
  19. sort(sum_index.begin(), sum_index.end());
  20. for (int i = 1; i < num_size + 1; ++i) {
  21. if (sum_index[i].first == sum_index[i - 1].first) {
  22. result.push_back(sum_index[i - 1].second);
  23. result.push_back(sum_index[i].second - 1);
  24. return result;
  25. }
  26. }
  27. return result;
  28. }
  29. };

源码分析

没啥好分析的,注意好边界条件即可。这里采用了链表中常用的「dummy」节点方法,pair排序后即为我们需要的排序结果。这种排序的方法需要先求得所有子串和然后再排序,最后还需要遍历排序后的数组,效率自然是比不上哈希表。但是在某些情况下这种方法有一定优势。

复杂度分析

遍历求子串和,时间复杂度为 O(n), 空间复杂度 O(n). 排序时间复杂度近似 O(n \log n), 遍历一次最坏情况下时间复杂度为 O(n). 总的时间复杂度可近似为 O(n \log n). 空间复杂度 O(n).

扩展

这道题的要求是找到一个即可,但是要找出所有满足要求的解呢?Stackoverflow 上有这道延伸题的讨论[^stackoverflow].

另一道扩展题来自 Google 的面试题 - Find subarray with given sum - GeeksforGeeks.

Reference